/*
 * Copyright 2004 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * $Header:$
 */
package org.apache.beehive.netui.script.common;

import org.apache.beehive.netui.util.logging.Logger;

/**
 *
 */
public class DataAccessProviderBean {

    private static final Logger _logger = Logger.getInstance(DataAccessProviderBean.class);

    private IDataAccessProvider _provider = null;

    public DataAccessProviderBean(IDataAccessProvider provider) {
        _provider = provider;
    }

    public Object getItem() {
        return _provider.getCurrentItem();
    }

    public Object getContainer() {
        return new DataAccessProviderBean(_provider.getProviderParent());
    }

    public int getIndex() {
        return _provider.getCurrentIndex();
    }

    public Object getMetadata() {
        return _provider.getCurrentMetadata();
    }
}


